// MMyHash.cpp: MMyHash NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MyHash.h"

// | KEY |\0|VALUE|\0| KEY |\0|VALUE|\0\0 <- terminator

static char	szEmpty[] = "";

//-----------------------------------------------------------------------------
// 񒆂̕ƂĔr܂B
int MyHash::StrCmpI( const char *str1, const char *str2 )
{
	do
	{
		if( ToLower(*str1) != ToLower(*str2) )
			return ToLower(*str2) - ToLower(*str1);
	}while( *str1++ && *str2++ );

	return 0;
}

//-----------------------------------------------------------------------------
// 񒆂̕r܂B
int MyHash::StrCmp( const char *str1, const char *str2 )
{
	do
	{
		if( *str1 != *str2 )
			return *str2 - *str1;
	}while( *str1++ && *str2++ );
	return 0;
}

//-----------------------------------------------------------------------------
//	@detail
//		RXgN^
//	@param
//	@return
//-----------------------------------------------------------------------------
MyHash::MyHash()
{
	m_pszSeekPointer = NULL;
	m_pHeap = new MyVarMem;
}

MyHash::~MyHash()
{
	if( m_pHeap )
		delete m_pHeap;
}

//-----------------------------------------------------------------------------
//	@detail
//		L[̒ǉ
//	@param
//		cahr*	pszKey		L[
//		char*	pszValue	l
//	@return
//		ǉoCg
//-----------------------------------------------------------------------------
int MyHash::Set( char* pszKey, char* pszValue )
{
	if( pszKey == NULL || pszValue == NULL )
		return 0;

	// -- ɃL[݂폜(㏑)

	if(SeekToKey( pszKey ) != NULL)
	{
		Del(pszKey);
	}

	// -- 
	int ret;
	int keylen = StrLen(pszKey) + 1;	// \0܂Ŋ܂߂
	int valuelen = StrLen(pszValue) + 1;

	char* record = new char[keylen + valuelen];
	memset(record, 0x00,	keylen + valuelen);
	memcpy(record,			pszKey,		keylen);
	memcpy(record + keylen,	pszValue,	valuelen);
	
	ret = m_pHeap->Add(record, keylen + valuelen);

	delete[] record;
	return ret;
}

//-----------------------------------------------------------------------------
//	@detail
//		R[h폜
//	@param
//		char* pszKey	폜L[
//	@return
//			1
//		s	0
//	@comment
//		폜̓̍Ĕzu܂B
//		̂ɃAxɎ኱sɓ܂B
//-----------------------------------------------------------------------------
int MyHash::Del( char* pszKey )
{
	char* pTop = (char*)m_pHeap->GetBuffer();
	char* pDelKey = SeekToKey(pszKey);

	// KeyȂƂ͏I
	if( pDelKey == NULL )
	{
		return 0;
	}

	int nTotalLen = m_pHeap->GetLength();

	// 폜̂擪ɂꍇ
	if(pTop == pDelKey)
	{
		MyVarMem* pHead = new MyVarMem;
		char* pNew = SeekNext();
		
		if( pNew != NULL )
		{
			pHead->Add(pNew, nTotalLen - (pNew - pTop));
		}
		delete m_pHeap;
		m_pHeap = pHead;
		SeekToFirst();
		return 1;
	}

	// 폜̂Ōɂꍇ
	char* pNext = SeekNext();

	if( pNext == NULL )
	{
		MyVarMem* pHead = new MyVarMem;
		int nNewLen = pDelKey - pTop;
		pHead->Add( pTop, nNewLen );
		delete m_pHeap;
		m_pHeap = pHead;
		
		SeekToFirst();
		return 1;
	}

	// rɂꍇ
	else
	{
		MyVarMem* pHead = new MyVarMem;
		
		int nHeadLen = pDelKey - pTop;
		pHead->Add(pTop, nHeadLen);

		int nTailLen = nTotalLen - (m_pszSeekPointer - pTop);
		pHead->Add(m_pszSeekPointer, nTailLen);

		delete m_pHeap;
		m_pHeap = pHead;
		
		SeekToFirst();
		return 1;
	}
}

//-----------------------------------------------------------------------------
//	@detail
//		lƂ
//	@param
//		char*	pszKey	L[
//	@return
//		 l
//-----------------------------------------------------------------------------
char* MyHash::GetValue( char* pszKey )
{
	char* p = (char*) m_pHeap->GetBuffer();

	p = SeekToKey(pszKey);
	if( p == NULL )
		return NULL;

	// Value ̓܂ňړ
	while(*p++ != '\0');
	
	return p;
}
//-----------------------------------------------------------------------------
//	@detail
//		lƂ
//	@param
//		char*	pszKey	L[
//				啶ʂ܂B
//	@return
//		 l
//-----------------------------------------------------------------------------
char* MyHash::GetValueI(char *pszKey)
{
	char* p = (char*) m_pHeap->GetBuffer();

	p = SeekToKeyI(pszKey);
	if( p == NULL )
		return NULL;

	// Value ̓܂ňړ
	while(*p++ != '\0');
	
	return p;

}

char* MyHash::GetValueE(char *pszKey)
{
	char* p = GetValue(pszKey);
	if( p )
		return p;
	else
		return szEmpty;

}

char* MyHash::GetValueIE(char *pszKey)
{
	char* p = GetValueI(pszKey);
	if( p )
		return p;
	else
		return szEmpty;

}

//-----------------------------------------------------------------------------
//	@detail
//		V[N|C^擪ɖ߂
//	@param
//	@return
//-----------------------------------------------------------------------------
char*	MyHash::SeekToFirst()
{
	m_pszSeekPointer = (char*)(m_pHeap->GetBuffer());
	return m_pszSeekPointer;
}

//-----------------------------------------------------------------------------
//	@detail
//		w肵L[܂ŃV[N|C^܂Ői
//	@param
//		char*	pszKey	L[
//	@return
//		L[΃L[Ԃ
//		sNULLԂ
//-----------------------------------------------------------------------------
char*	MyHash::SeekToKey(char* pszKey)
{
	SeekToFirst();
	char* p = (char*) m_pHeap->GetBuffer();

	if( p == NULL )
	{
		return NULL;
	}

	while(this->StrCmp(p, pszKey) != 0)
	{
		p = SeekNext();
		if( p == NULL )
			return NULL;
		
	}
	return (m_pszSeekPointer = p);
}
//-----------------------------------------------------------------------------
//	@detail
//		w肵L[܂ŃV[N|C^܂Ői
//	@param
//		char*	pszKey	L[
//				啶݂܂B
//	@return
//		L[΃L[Ԃ
//		sNULLԂ
//-----------------------------------------------------------------------------
char*	MyHash::SeekToKeyI(char* pszKey)
{
	SeekToFirst();
	char* p = (char*) m_pHeap->GetBuffer();

	if( p == NULL )
	{
		return NULL;
	}

	while(StrCmpI(p, pszKey) != 0)
	{
		p = SeekNext();
		if( p == NULL )
			return NULL;
		
	}
	return (m_pszSeekPointer = p);
}

//-----------------------------------------------------------------------------
//	@detail
//		݂̃L[̒lԂ
//	@param
//		Ȃ
//	@return
//		݂̃L[Ԃ
//-----------------------------------------------------------------------------
char*	MyHash::GetCurrentKey()
{
	return m_pszSeekPointer;
}

//-----------------------------------------------------------------------------
//	@detail
//		݂̒lԂ
//	@param
//		Ȃ
//	@return
//		݂̒lԂ
//-----------------------------------------------------------------------------
char*	MyHash::GetCurrentValue()
{
	if( m_pszSeekPointer == NULL )
	{
		return NULL;
	}
	char* p = m_pszSeekPointer;
	// Value ܂ňړ
	while(*p++ != '\0');

	return p;
}

//-----------------------------------------------------------------------------
//	@detail
//		̃L[܂ŃV[N|C^i߂
//	@param
//		
//	@return
//		̃L[Ԃ
//-----------------------------------------------------------------------------
char*	MyHash::SeekNext()
{
	if( m_pszSeekPointer == NULL )
	{
		return NULL;
	}
	char* p = m_pszSeekPointer;
		
	// Value ̓܂ňړ
	while(*p++ != '\0');
	
	// Value  "" ̏ꍇ
	if( p[0] == '\0' && p[1] == '\0' )
	{

		return NULL;
	}

	//  Key ܂ňړ
	while(*p++ != '\0');

	// I[(\0\0)ANULLԂ
	if( *p == '\0' )
	{
		m_pszSeekPointer = p;
		return NULL;
	}

	return (m_pszSeekPointer = p);
}
/*
//-----------------------------------------------------------------------------
//	@detail
//		SẴR[h폜
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
void MyHash::DeleteAll()
{
	m_pHeap->Clear();
	m_pszSeekPointer = NULL;
}
*/

void* MyHash::GetBuffer() const
{
	return m_pHeap->GetBuffer();
}


