// MySock.cpp: MySock NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MySock.h"
#include "MyVarMem.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MySock::MySock()
{
	m_status = 0;
	m_socket = INVALID_SOCKET;
	// o[WłUDP/IP̓T|[gĂȂ
	m_nProtocol = SOCK_STREAM;

	// ftHg̃^CAEgl
	SetTimeOut(1,0);

}

MySock::MySock(SOCKET s)
{
	// winsock̏
	InitDll();
	m_status = 0;
	m_socket = s;
	// o[WłUDP/IP̓T|[gĂȂ
	m_nProtocol = SOCK_STREAM;

	// ftHg̃^CAEgl
	SetTimeOut(1,0);

	if(m_socket == INVALID_SOCKET)
	{
		return;
	}

	int ioctl_opt =1;
	
	if (ioctlsocket(m_socket, FIONBIO,(unsigned long*)&ioctl_opt) == SOCKET_ERROR)
	{
		return;
	}

}

MySock::~MySock()
{
	Close();
}

//-----------------------------------------------------------------------------
//	@detail
//		MJn
//	@param
//	@return
//				:\Pbg
//		s		:SOCKET_ERROR
//		^CAEg:0
//-----------------------------------------------------------------------------
SOCKET MySock::Accept()
{
	sockaddr_in from;
	return Accept(&from);
}

SOCKET MySock::Accept(sockaddr_in* pFrom)
{
	fd_set	readfds;
	int i = 0;

	FD_ZERO(&readfds);
	FD_SET(m_socket,&readfds);
	

	i = ::select(0, &readfds, NULL, NULL, &m_timeout);

	// \PbgG[		i == SOCKET_ERROR
	// ^CAEg			i == 0
	if( i < 1 )
	{
		return INVALID_SOCKET;
	}

	int fromlen = sizeof(sockaddr_in);
	return ::accept(m_socket, (sockaddr*)pFrom, &fromlen);
}

//-----------------------------------------------------------------------------
//	@detail
//		Ҏ󂯂Jn
//	@param
//		int nPort	|[gԍ
//	@return
//				:\Pbg
//		s		:SOCKET_ERROR
//-----------------------------------------------------------------------------
int MySock::Listen(int nPort)
{
	if(m_socket != INVALID_SOCKET)
	{
		Close();
	}

	sockaddr_in local;

	local.sin_family = AF_INET;			// TCP/IP
	local.sin_addr.s_addr = INADDR_ANY;	// SẴlbg[NA_v^
	local.sin_port = htons(nPort);		// |[gԍ

	m_socket = socket(AF_INET, SOCK_STREAM,0);

	if (m_socket == INVALID_SOCKET)
	{
		return SOCKET_ERROR;
	}
	//	bind
	if (::bind(m_socket,(struct sockaddr*)&local,sizeof(local) ) == SOCKET_ERROR)
	{
		return SOCKET_ERROR;
	}
	// listen
	if (::listen(m_socket,SOMAXCONN) == SOCKET_ERROR)
	{
		return SOCKET_ERROR;
	}

	// non blocking option
	int ioctl_opt = 1;
	if (::ioctlsocket(m_socket,FIONBIO,(unsigned long*)&ioctl_opt) == SOCKET_ERROR)
	{
		return SOCKET_ERROR;
	}

	return 1;

}

//-----------------------------------------------------------------------------
//	@detail
//		Winsock̏
//	@param
//	@return
//-----------------------------------------------------------------------------
int MySock::InitDll()
{
	static initdone = 0;
    if (!initdone)
	{
		initdone = 1;

		WSADATA	wsaData;
		int winsockstartup = WSAStartup(WINSOCK_VERSION_REQUIRED,&wsaData);
		
		if (winsockstartup != 0 ||
			wsaData.iMaxSockets < WINSOCK_MIN_SOCKETS_REQUIRED)
		{
			WSACleanup();
			return FALSE;
		}
    }
	return TRUE;
}

//-----------------------------------------------------------------------------
//	@detail
//		ڑ
//	@param
//		char*	ipaddr	:IPAhXzXg
//		char*	port	:|[gԍ
//	@return
//					:0
//		s			:SOCKET_ERROR
//-----------------------------------------------------------------------------
int MySock::Connect(char* ipaddr, char* port)
{
	DWORD ip;

	ip = inet_addr(ipaddr);

	if (ip == INADDR_NONE)
	{
		// DNSɕ
		struct hostent* pHost;
		pHost = gethostbyname(ipaddr);
		
		if (pHost == NULL)
		{
			return SOCKET_ERROR;
		}
		
		ip = *((DWORD*)(pHost->h_addr));
	}

	SOCKADDR_IN sockaddr;
	sockaddr.sin_family = AF_INET;
	sockaddr.sin_port   = htons(atoi(port));
	sockaddr.sin_addr.s_addr = ip;
	m_socket = socket(AF_INET, SOCK_STREAM,0);

	m_status = ::connect(m_socket, (const struct sockaddr*)&sockaddr, sizeof(sockaddr));

	if (m_status != 0)
	{
		Close();
	}
	
	return m_status;
}

//-----------------------------------------------------------------------------
//	@detail
//		f[^̑M
//	@param
//		char*	buf	:f[^|C^
//		int		len	:mۂĂTCY
//		int		flag:
//	@return
//				:MoCg
//		s		:SOCKET_ERROR
//		^CAEg:0
//-----------------------------------------------------------------------------
int MySock::SendData(char *buf, int len, int flag)
{
	fd_set writefds;
	FD_ZERO(&writefds);
	FD_SET(m_socket, &writefds);
	int i = 0;

	if(m_socket == INVALID_SOCKET)
	{
		return SOCKET_ERROR;
	}
	
	if( len == 0 && buf != NULL)
		len = strlen(buf);

	int nTotalSend = 0;
	int nSendLen = 0;

	do
	{
		nSendLen = 0;
		i = ::select(0, NULL, &writefds, NULL, &m_timeout);

		// \PbgG[		i == SOCKET_ERROR
		// ^CAEg			i == 0
		if( i < 1 )
		{
			return SOCKET_ERROR;
		}

		// ^CAEgtM
		if( FD_ISSET(m_socket, &writefds) )
		{
			// nSendLen = ::send( m_socket, buf, len, flag );
			nSendLen = ::send( m_socket, &buf[nTotalSend], len - nTotalSend, flag );
			if( nSendLen > 0)
				nTotalSend += nSendLen;
			else
				break;
			
		}
	}while( nTotalSend < len );


	return nSendLen;

}

//-----------------------------------------------------------------------------
//	@detail
//		f[^Ms܂B
//	@param
//		char*	buf	:f[^|C^
//		int		len	:mۂĂTCY
//		int		flag:
//	@return
//				:MoCg
//		s		:SOCKET_ERROR
//		^CAEg:0
//		ؒf		:SOCKET_ERROR
//-----------------------------------------------------------------------------
int MySock::RecvData(char *buf, int len, int flag)
{
	fd_set	readfds;
	FD_ZERO(&readfds);
	FD_SET(m_socket,&readfds);
	int i = 0;
	int nRecvLen = 0;

	if(m_socket == INVALID_SOCKET)
	{
		return SOCKET_ERROR;
	}

	i = ::select(0, &readfds, NULL, NULL, &m_timeout);

	// \PbgG[		i == SOCKET_ERROR
	// ^CAEg			i == 0
	if( i < 1 )
	{
		return i;
	}

	// ǂ߂
	if (FD_ISSET(m_socket, &readfds))
	{

		nRecvLen = ::recv(m_socket, buf, len, flag);
	}

	// MSDN says...
	// Zero indicates that the connection has been gracefully closed.
	// SOCKET_ERROR indicates failure.
	// To get a specific error value, call WSAGetLastError.
	if( nRecvLen == 0 )
	{
		return SOCKET_ERROR;
	}
	return nRecvLen;

}

//-----------------------------------------------------------------------------
//	@detail
//		\Pbg
//	@param
//	@return
//-----------------------------------------------------------------------------
void MySock::Close()
{
	if(m_socket != INVALID_SOCKET)
	{
		::shutdown(m_socket, 2);
		::closesocket(m_socket);
		m_socket = INVALID_SOCKET;
	}

}

//-----------------------------------------------------------------------------
//	@detail
//		\Pbgǂ݉\ԁAANZvg\Ԃׂ
//	@param
//	@return
//		see ::select
//		s		:SOCKET_ERROR
//		^CAEg:0
//		ؒf		:0
//-----------------------------------------------------------------------------
int MySock::IsReadalbe()
{
	fd_set	readfds;

	FD_ZERO(&readfds);
	FD_SET(m_socket,&readfds);
	return ::select(0, &readfds, NULL, NULL, &m_timeout);

}
